// --------------------------
// RP Jobs :: Bricks
// --------------------------

if (isPackage(RP_Jobs_Bricks_Core))
	deactivatePackage(RP_Jobs_Bricks_Core);

package RP_Jobs_Bricks_Core
{
	// Planting a brick
	function fxDTSBrick::onPlant(%brick)
	{
		Parent::onPlant(%brick);
		
		if (!isObject(%brick))
			return false;
		
		%datablock = %brick.getDatablock();
		
		if (%datablock.isSpawnBrick)
			%brick.AddSpawn();
	}
	
	// Killing a brick
	function fxDTSBrick::onDeath(%brick)
	{
		if (%brick.getDatablock().isSpawnBrick)
			RemoveSpawn(%brick);
		Parent::onDeath(%brick);
	}
};
activatePackage(RP_Jobs_Bricks_Core);

if (isPackage(RP_Jobs_Bricks))
	deactivatePackage(RP_Jobs_Bricks);

package RP_Jobs_Bricks
{
	// When planting a brick
	function fxDTSBrick::PlantBrick(%brick)
	{
		Parent::PlantBrick(%brick);
		
		%brickGroup = getBrickGroupFromObject(%brick);
		%client = %brickGroup.client;
		
		// Check job build rights
		if (!(%client.isAdmin || $RP::job::build[%client.RPData.value["jobID"]]))
		{
			commandToClient(%client, 'centerPrint', "\c3Your job is not allowed to build.", 3);
			%brick.schedule(0, "delete");
			return false;
		}
	}
};
RPRegPackage(RP_Jobs_Bricks);

// Add spawn to list
function fxDTSBrick::AddSpawn(%brick)
{
	$RP::spawnPoints = addToList($RP::spawnPoints, %brick);
}

// Remove spawn from list
function RemoveSpawn(%brick)
{
	$RP::spawnPoints = removeFromList($RP::spawnPoints, %brick);
}