// --------------------------
// RP Jobs :: Game
// --------------------------

if (isPackage(RP_Jobs_Game_Core))
	deactivatePackage(RP_Jobs_Game_Core);

package RP_Jobs_Game_Core
{
	// Booting game
	function BootRP()
	{
		if ($RP::activated)
			return;
		Parent::BootRP();
		
		RPDB.addValue("jobID", 1); // Tourist
		RPDB.saveDefs();
		
		RP_AddStat("Job", "jobID", 1, "RP::job::name");
	}
};
activatePackage(RP_Jobs_Game_Core);

if (isPackage(RP_Jobs_Game))
	deactivatePackage(RP_Jobs_Game);

package RP_Jobs_Game
{
	// RP Player tick
	function CheckTickID(%ID)
	{
		%name = RPDB.get(%ID, "name");
		%client = findClientByName(%name);
		if (!isObject(%client))
			return false;
		
		if (RPModExist("Money"))
		{
			// Get temporary variables
			%job = %client.RPData.value["jobID"];
			%payTime = $RP::job::paytime[%job];
			%pay = $RP::job::pay[%job];
			%times = getWordCount(%payTime);
			
			%payment = 0;
			
			// Sort of payment
			switch (%times)
			{
				// No payment
				case 0:
					%payment = 0;
				// Get paid between two times
				case 2:
					// Get from between
					%from = atoi(getWord(%payTime, 0));
					%to = atoi(getWord(%payTime, 1));
					
					if (%from < $RP::pref::timeHour && %to >= $RP::pref::timeHour)
						%payment = %pay;
					
				// More than 2 or 1
				// Get paid certain times
				default:
					for (%i = 0; %i < %times; %i++)
					{
						if (atoi(getWord(%payTime, %i)) == $RP::pref::timeHour)
						{
							%payment = %pay;
							break;
						}
					}
			}
			// Paytime
			if (%payment > 0)
			{
				// Transfer to bank
				if (%client.RPData.getBool("tickBank"))
				{
					%client.RPData.value["bank"] += %payment;
					messageClient(%client, '', '\c3%1\c6 has been deposited to your bank account.', prepareDisplayMoney(getMetricPrefix(%payment)));
				}
				// Transfer to player
				else
				{
					%client.RPData.value["money"] += %payment;
					messageClient(%client, '', '\c6You have been paid \c3%1\c6.', prepareDisplayMoney(getMetricPrefix(%payment)));
				}
			}
		}
		
		// Promotion
		Promotion(%client);
		
		Parent::CheckTickID(%ID);
	}
};
RPRegPackage(RP_Jobs_Game);

// Find spawnpoint
function FindSpawn(%search, %id)
{
	%amount = getWordCount($RP::spawnPoints);
	for (%i = 0; %i < %amount; %i++)
	{
		%brick = getWord($RP::spawnPoints, %i);
		
		//Spawn does not exist
		if (!isObject(%brick))
		{
			RemoveSpawn(%brick);
			continue;
		}
		
		// Wrong spawn
		if (strLwr(%brick.getDatablock().spawnData) !$= strLwr(%search @ (%id ? " " @ %id : "")) && strLwr(%search) !$= strLwr("personalSpawn"))
			continue;
		
		// Personal spawn?
		if (strLwr(%search) $= strLwr("personalSpawn") && (strLwr(%brick.getDatablock().spawnData) !$= strLwr("personalSpawn") || getBrickGroupFromObject(%brick).client != %id))
			continue;
		
		%pSpawns = (%pSpawns $= "") ? %brick : %pSpawns SPC %brick;
	}
	
	if (%pSpawns !$= "")
	{
		%spawnBrick = getWord(%pSpawns, getRandom(0, getWordCount(%pSpawns) - 1));
		return vectorSub(%spawnBrick.getWorldBoxCenter(), "0 0" SPC (%spawnBrick.getDatablock().brickSizeZ - 3) * 0.1) SPC getWords(%spawnBrick.getTransform(), 3, 6);
	}
	
	return "";
}